using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Data;
using System.Windows;
using Softix.Orchestration.Core.Components;

namespace Softix.Drawing.Diagram.Wpf.Core
{
	internal sealed class ComponentLinkDestinationConverter : IMultiValueConverter
	{
		public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (false == (parameter is ComponentLinkDestinationInfo))
				throw new Exception("The method or operation is not implemented.");

			ComponentLinkDestinationInfo targetInfo = (ComponentLinkDestinationInfo)parameter;

			double left = (double)values[0];
			double top = (double)values[1];
			double width = (double)values[2], right = left + width;
			double height = (double)values[3], bottom = top + height;

			switch (targetInfo.DestinationSide)
			{
				case ComponentLinkDestinationSide.Left:
					return new Point(left, top + height / 2);
				case ComponentLinkDestinationSide.Top:
					return new Point(left + width / 2, top);
				case ComponentLinkDestinationSide.Right:
					return new Point(right, top + height / 2);
				case ComponentLinkDestinationSide.Bottom:
					return new Point(left + width / 2, bottom);
				default:
					return new Point(0, 0);
			}
		}

		public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
		{
			throw new Exception("The method or operation is not implemented.");
		}
	}
}
