using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Data;
using System.Globalization;
using Softix.Orchestration.Core.Components;
using Softix.Drawing.Diagram.Wpf.Controls;
using System.Windows;
using System.Windows.Media;
using System.Windows.Controls;

namespace Softix.Drawing.Diagram.Wpf.Core
{
	internal sealed class ComponentLinkSourceConverter : IMultiValueConverter
	{
		public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
		{
			if (false == (parameter is ComponentLinkSourceInfo))
				throw new Exception("The method or operation is not implemented.");

			ComponentLinkSourceInfo sourceInfo = (ComponentLinkSourceInfo)parameter;

			double left = (double)values[0];
			double top = (double)values[1];
			double width = (double)values[2], right = left + width;
			double height = (double)values[3], bottom = top + height;

			// x
			double x = ((sourceInfo.SourceSide == ComponentLinkSourceSide.Left) ? left - 4 : right + 4);

			// y
			double y = 0;
			ComponentPathInfo info = sourceInfo.PathInfo;
			Guid pathId = info.PathId;
			int count = sourceInfo.Host.ComponentPaths.Length;
			for (int index = 1; index <= count; index++)
			{
				if (sourceInfo.Host.ComponentPaths[count - index].PathId == pathId)
				{
					y = bottom
						- index * 14 /* sourceInfo.PathHost.ActualHeight */
						+ 7 /* sourceInfo.PathHost.ActualHeight / 2 */;
				}
			}

			// return converted value
			return new Point(x, y);
		}

		public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
		{
			throw new Exception("The method or operation is not implemented.");
		}
	}
}
