using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Windows.Forms.Integration;
using Softix.Drawing.Diagram.Wpf.Core;
using Softix.Orchestration.Core.Components;
using System.Windows;
using Softix.Drawing.Diagram.Wpf.Controls;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core;

namespace Softix.Drawing.Diagram.Wpf
{
    public sealed class ModelEditorHost : System.Windows.Forms.UserControl
    {
		private ElementHost host;
		private ModelEditor editor;

        public ModelEditorHost(IAmModel model)
        {
            this.SetModel(model);
        }

		/// <summary>
		/// Gets the child <see cref="ModelEditor"/> of this host.
		/// </summary>
		public ModelEditor Editor
		{
			get { return this.editor; }
		}

		public IInputElement RootElement
		{
			get { return this.editor; }
		}

        public void SetModel(IAmModel model)
        {
            this.Controls.Clear();

            // create host
            this.host = new ElementHost();
            this.host.Dock = System.Windows.Forms.DockStyle.Fill;
			this.host.AllowDrop = true;
            this.Controls.Add(this.host);

            // create editor
            this.editor = new ModelEditor(model);
            this.host.Child = this.editor;
        }
    }
}
