using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.IO;
using System.Windows.Markup;

namespace Softix.Drawing.Diagram.Wpf.Resources
{
	internal static class StyleRepository
	{
		private const string COMPONENT_STYLES_XAML = "Softix.Drawing.Diagram.Wpf.Resources.ComponentStyles.xaml";
		private const string COMPONENT_LINK_STYLES_XAML = "Softix.Drawing.Diagram.Wpf.Resources.ComponentLinkStyles.xaml";
		private static ResourceDictionary dictionary = null;

		private static ResourceDictionary Dictionary
		{
			get
			{
				if (StyleRepository.dictionary == null)
				{
					StyleRepository.dictionary = new ResourceDictionary();
					using (Stream stream = typeof(StyleRepository).Assembly.GetManifestResourceStream(COMPONENT_STYLES_XAML))
					{
						StyleRepository.dictionary.MergedDictionaries.Add((ResourceDictionary)XamlReader.Load(stream));
					}
					using (Stream stream = typeof(StyleRepository).Assembly.GetManifestResourceStream(COMPONENT_LINK_STYLES_XAML))
					{
						StyleRepository.dictionary.MergedDictionaries.Add((ResourceDictionary)XamlReader.Load(stream));
					}
				}
				return StyleRepository.dictionary;
			}
		}

		internal static Style TopLeftThumbStyle { get { return (Style)StyleRepository.Dictionary["TopLeftResizeAdorner"]; } }
		internal static Style BottomLeftThumbStyle { get { return (Style)StyleRepository.Dictionary["BottomLeftResizeAdorner"]; } }
		internal static Style TopRightThumbStyle { get { return (Style)StyleRepository.Dictionary["TopRightResizeAdorner"]; } }
		internal static Style BottomRightThumbStyle { get { return (Style)StyleRepository.Dictionary["BottomRightResizeAdorner"]; } }
		internal static Style CenterThumbStyle { get { return (Style)StyleRepository.Dictionary["CenterResizeAdorner"]; } }

		internal static Style ComponentPathTargetThumbStyle { get { return (Style)StyleRepository.Dictionary["ComponentPathTargetThumbStyle"]; } }
		internal static Style LinkSourceMoveButtonLeft { get { return (Style)StyleRepository.Dictionary["LinkSourceMoveButtonLeft"]; } }
		internal static Style LinkSourceMoveButtonRight { get { return (Style)StyleRepository.Dictionary["LinkSourceMoveButtonRight"]; } }
		internal static Style LinkSourceDeleteButton { get { return (Style)StyleRepository.Dictionary["LinkSourceDeleteButton"]; } }
		internal static Style LinkTargetMoveButtonLeft { get { return (Style)StyleRepository.Dictionary["LinkTargetMoveButtonLeft"]; } }
		internal static Style LinkTargetMoveButtonTop { get { return (Style)StyleRepository.Dictionary["LinkTargetMoveButtonTop"]; } }
		internal static Style LinkTargetMoveButtonRight { get { return (Style)StyleRepository.Dictionary["LinkTargetMoveButtonRight"]; } }
		internal static Style LinkTargetMoveButtonBottom { get { return (Style)StyleRepository.Dictionary["LinkTargetMoveButtonBottom"]; } }

		internal static Style ComponentHostStyle { get { return (Style)StyleRepository.Dictionary["ComponentHostStyle"]; } }
		internal static Style DiagramEditorStyle { get { return (Style)StyleRepository.Dictionary["DiagramEditorStyle"]; } }
	}
}
