using System;
using System.Data;
using System.Configuration;

namespace Softix.Orchestration.Core.Designers
{
	public sealed class DesignerCommand
	{
		private Guid commandId;
		private string commandLabel;
		private string commandImageResource;
		private bool enabled = true;

		public DesignerCommand(string commandLabel)
		{
			this.commandId = Guid.NewGuid();
			this.commandLabel = commandLabel;
		}

		public DesignerCommand(string commandLabel, EventHandler clickHandler)
			: this(commandLabel)
		{
			this.Click += clickHandler;
		}

		public DesignerCommand(string commandLabel, string commandImageResource, EventHandler clickHandler)
			: this(commandLabel, clickHandler)
		{
			this.commandImageResource = commandImageResource;
		}

		public Guid CommandId { get { return this.commandId; } }
		public string CommandLabel { get { return this.commandLabel; } }
		public string CommandImageResource { get { return this.commandImageResource; } }
		public bool Enabled { get { return this.enabled; } set { this.enabled = value; } }

		public event EventHandler Click;

		private void OnClick()
		{
			if (this.Click != null)
				this.Click(this, EventArgs.Empty);
		}

		public void Select()
		{
			this.OnClick();
		}
	}
}
