using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Core.Designers.Editors
{
    public partial class BrowseDataForm : Form
    {
        public BrowseDataForm(IAmComponent component)
        {
            InitializeComponent();

            if ((component != null) && (component.ParentModel != null))
            {
                VariableList defs = new VariableList(
                    component.ParentModel.GetVariablesForComponent(component));

                foreach (Variable def in defs.UniqueVariables)
                {
                    TreeNode node = new TreeNode(def.Name + " (" + def.DataType.DataTypeName + ")");

                    IAmComponent source = component.ParentModel.GetComponent(def.SourceComponentID);
                    if (source != null)
                        node.Text = source.Name + ": " + node.Text;

                    def.RunValidation();

                    if (def.IsValid == false)
                    {
                        node.ImageIndex = node.SelectedImageIndex = 2;
                    }
                    else if (def.IsArray == true)
                    {
                        node.ImageIndex = node.SelectedImageIndex = 1;
                    }
                    else
                    {
                        node.ImageIndex = node.SelectedImageIndex = 0;
                    }
                    tvw.Nodes.Add(node);
                }
            }
        }
    }
}