using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Softix.Orchestration.Core.Designers.Editors
{
	public partial class DesignableEditor : Form
	{
		private ImageList images;

		public DesignableEditor()
		{
			InitializeComponent();
		}

		public void AddDesignerPage(DesignerPage page)
		{
			this.tabs.TabPages.Add(page);
			this.RefreshTabImage(page);
		}

		public void RemoveDesignerPage(Guid pageId)
		{
			throw new NotImplementedException("Lazy programmer.");
		}

		public void RemoveDesignerPage(DesignerPage page)
		{
			throw new NotImplementedException("Lazy programmer.");
		}

		public void ClearDesignerPages()
		{
			throw new NotImplementedException("Lazy programmer.");
		}

		private void RefreshTabImage(DesignerPage page)
		{
			if (this.images == null)
			{
				this.images = new ImageList();
				this.images.ImageSize = new Size(16, 16);
				this.images.TransparentColor = Color.Transparent;
				this.tabs.ImageList = this.images;
				if (this.components == null)
					this.components = new Container();
				this.components.Add(this.images);
			}

			Image image = page.TabImage;
			if (image != null)
			{
				page.ImageIndex = this.images.Images.Add(image, Color.Transparent);
			}
			else
			{
				page.ImageIndex = -1;
			}
		}

		public DesignerPage[] DesignerPages
		{
			get
			{
				if (this.tabs.TabPages.Count == 0)
					return null;

				List<DesignerPage> list = new List<DesignerPage>();
				foreach (TabPage page in this.tabs.TabPages)
				{
					if (page is DesignerPage)
						list.Add((DesignerPage)page);
				}
				return list.ToArray();
			}
			set
			{
				this.tabs.TabPages.Clear();
				if ((value != null) && (value.Length > 0))
				{
					foreach (DesignerPage page in value)
						this.AddDesignerPage(page);
				}
			}
		}

		private void btnOk_Click(object sender, EventArgs e)
		{
			DesignerPage[] pages = this.DesignerPages;
			if ((pages != null) && (pages.Length > 0))
			{
				foreach (DesignerPage page in pages)
					page.Close();
			}
			this.Close();
		}
	}
}