using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Softix.Orchestration.Core.Designers.Editors.MappingEditors
{
    internal sealed class SimpleTypeDescriptorContext : ITypeDescriptorContext
    {
        private Object instance = null;
        private IServiceProvider provider = null;
        private PropertyDescriptor property = null;

        public SimpleTypeDescriptorContext(
            IServiceProvider provider,
            Object instance,
            String propertyName)
        {
            this.provider = provider;
            this.instance = instance;

            if (this.instance != null)
            {
                this.property = TypeDescriptor.GetProperties(this.instance).Find(propertyName, true);
            }
        }

        #region ITypeDescriptorContext Members

        public IContainer Container
        {
            get { return null; }
        }

        public object Instance
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public void OnComponentChanged()
        {
        }

        public bool OnComponentChanging()
        {
            return true;
        }

        public PropertyDescriptor PropertyDescriptor
        {
            get { return this.property; }
        }

        #endregion

        #region IServiceProvider Members

        public object GetService(Type serviceType)
        {
            if (provider != null)
                return provider.GetService(serviceType);
            return null;
        }

        #endregion
    }
}
