using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Data.Mappers;

namespace Softix.Orchestration.Core.Designers.Editors.MappingEditors
{
    public partial class VariablePicker : Form
    {
        public VariablePicker(IAmComponent component, IAmDataType target, IVariableMapper mapper)
        {
            InitializeComponent();

            this.Text = "Pick Variable: " + target.DataTypeName; 
            this.picker.Load(
                component.ParentModel,
                component,
                target,
                mapper);
            if (this.picker.IsEmpty == true)
                this.btnOK.Enabled = false;
        }

        public IVariableMapper Mapper
        {
            get { return picker.Save(); }
        }
    }
}