using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Core.Designers.Editors
{
    public sealed class ModelInputVariablesPage : DesignerPage
    {
        private IAmModel model;
        private VariableCollectionEditor editor;

        public ModelInputVariablesPage(IAmModel model)
        {
            this.Text = "Model Inputs";
            this.model = model;

            this.InitializeComponents();
        }

        private void InitializeComponents()
        {
            this.editor = new VariableCollectionEditor(this.model.InitialVariables);
            this.editor.Dock = System.Windows.Forms.DockStyle.Fill;
            this.Controls.Add(this.editor);
        }

        public override System.Drawing.Image TabImage
        {
            get { return Resources.Resources.ArrowRightGreen; }
        }

        public override void Close()
        {
            base.Close();

            List<Variable> list = new List<Variable>();
            IEnumerable<Variable> finalVariables = this.editor.FinalVariables;
            if (finalVariables != null)
                list.AddRange(finalVariables);
            this.model.InitialVariables = list.ToArray();
        }
    }
}
