using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;

namespace Softix.Orchestration.Core.Designers.Editors
{
	public sealed class PropertyGridPage : DesignerPage
	{
		private PropertyGrid grid;

		public PropertyGridPage()
		{
			this.Text = "Properties";

			this.grid = new PropertyGrid();
			this.grid.Dock = DockStyle.Fill;
			this.Controls.Add(this.grid);
		}

		public PropertyGridPage(object toBeEdited)
			: this()
		{
			this.EditedObject = toBeEdited;
		}

		public object EditedObject
		{
			get { return this.grid.SelectedObject; }
			set { this.grid.SelectedObject = value; }
		}

		public override System.Drawing.Image TabImage
		{
			get { return Resources.Resources.Edit; }
		}
	}
}
