using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Softix.Orchestration.Core.Data;
using System.ComponentModel;

namespace Softix.Orchestration.Core.Designers.Editors
{
    public sealed class VariableListItem : ListViewItem
    {
        private Variable variable;

        public VariableListItem(Variable variable)
        {
            this.variable = variable;
            this.variable.PropertyChanged += OnVariablePropertyChanged;

            this.RefreshIsValidImage();
            this.RefreshName();
        }

        private void OnVariablePropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "IsValid")
                this.RefreshIsValidImage();
            else if ((e.PropertyName == "Name") || (e.PropertyName == "DataType"))
                this.RefreshName();
        }

        private void RefreshIsValidImage()
        {
            this.ImageIndex = (this.variable.IsValid == true) ? 0 : 1;
        }

        private void RefreshName()
        {
            this.Text = String.Format("{0} ({1})",
                this.variable.Name,
                (this.variable.DataType != null) ? this.variable.DataType.DataTypeName : "no type info");
        }

        public Variable Variable { get { return this.variable; } }
    }
}
