using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Softix.Orchestration.Core.Designers.Resources
{
	internal static class Resources
	{
		private static Dictionary<string, Image> images = new Dictionary<string, Image>();

		private static Image GetImage(string resource)
		{
			if (images.ContainsKey(resource) == true)
				return images[resource];

			Image image = new Bitmap(typeof(Resources), resource);
			images.Add(resource, image);
			return image;
		}

		internal static Image Edit { get { return GetImage("edit.png"); } }
		internal static Image Import { get { return GetImage("import.png"); } }
		internal static Image Export { get { return GetImage("export.png"); } }

        internal static Image ArrowRightBlue { get { return GetImage("arrow_right_blue.png"); } }
        internal static Image ArrowRightGreen { get { return GetImage("arrow_right_green.png"); } }
	}
}
