using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Validation;

namespace Softix.Orchestration.Deployment.Assembly
{
	public sealed class AssemblyDeployer : IDeployModels
	{
		#region IDeployModels Members

        public string Label { get { return "Deploy as Assembly"; } }
        public bool CanDeploy(IAmModel model) { return true; }

		public void Deploy(IAmModel model)
		{
            if (model is ISupportValidation)
            {
                ISupportValidation validable = (ISupportValidation)model;
                validable.RunValidation();
                if (validable.IsValid == false)
                    throw new InvalidOperationException("Model is not valid!");
            }

			using (AssemblyDeployerUI ui = new AssemblyDeployerUI(model))
			{
				ui.ShowDialog();
			}
		}

		#endregion
	}
}
