using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Softix.Orchestration.Deployment.Internals
{
	internal static class ValidationUtil
	{
		private readonly static Regex reClassName;
		private readonly static Regex reNamespace;

		static ValidationUtil()
		{
			reClassName = new Regex(
				"^[_a-z][_a-z0-9]*$",
				RegexOptions.Compiled | RegexOptions.Singleline | RegexOptions.IgnoreCase);
			reNamespace = new Regex(
				"^[_a-z][_a-z0-9]*(.[_a-z][_a-z0-9]*)*$",
				RegexOptions.Compiled | RegexOptions.Singleline | RegexOptions.IgnoreCase);
		}

		internal static bool ValidateClassName(string className)
		{
			return reClassName.IsMatch(className);
		}

		internal static bool ValidateNamespace(string @namespace)
		{
			return reNamespace.IsMatch(@namespace);
		}
	}
}
