using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.ServiceModel.Configuration;

namespace Softix.Orchestration.Deployment.WcfService
{
	internal static class ConfigFileGenerator
	{
		internal static void GenerateConfigFile(string exePath, string protocol, string serviceNamespace, string serviceName, string port)
		{
			Configuration config = ConfigurationManager.OpenExeConfiguration(exePath);
			config.SectionGroups.Clear();

			ServiceModelSectionGroup serviceModel = (ServiceModelSectionGroup)config.GetSectionGroup("system.serviceModel");
			ServiceElement service = new ServiceElement(String.Format("{0}.{1}", serviceNamespace, serviceName));
			serviceModel.Services.Services.Add(service);

			// behaviors
			ServiceBehaviorElement behavior = new ServiceBehaviorElement("metadataSupport");
			ServiceMetadataPublishingElement metadataPubliser = new ServiceMetadataPublishingElement();
			metadataPubliser.HttpGetEnabled = true;
			behavior.Add(metadataPubliser);
			serviceModel.Behaviors.ServiceBehaviors.Add(behavior);

			// endpoints
			service.Endpoints.Clear();
			service.BehaviorConfiguration = behavior.Name;
			ServiceEndpointElement endpoint = new ServiceEndpointElement();
			endpoint.Contract = String.Format("{0}.I{1}Service", serviceNamespace, serviceName);
			endpoint.Binding = "basicHttpBinding";
			service.Endpoints.Add(endpoint);
			ServiceEndpointElement endpointMex = new ServiceEndpointElement();
			endpointMex.Contract = "IMetadataExchange";
			endpointMex.Binding = "mexHttpBinding";
			endpointMex.Address = new Uri(String.Format("{0}://localhost:{1}/{2}Mex", protocol, port, serviceName));
			service.Endpoints.Add(endpointMex);

			// address
			BaseAddressElement address = new BaseAddressElement();
			address.BaseAddress = String.Format("{0}://localhost:{1}/{2}", protocol, port, serviceName);
			service.Host.BaseAddresses.Add(address);

			config.Save();
		}
	}
}
