using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Validation;

namespace Softix.Orchestration.Deployment.WcfService
{
	public sealed class WcfServiceDeployer : IDeployModels
	{
		#region IDeployModels Members

        public string Label { get { return "Deploy as WCF Service"; } }
        public bool CanDeploy(IAmModel model) { return true; }
        
        public void Deploy(IAmModel model)
		{
			if (model is ISupportValidation)
			{
				ISupportValidation validable = (ISupportValidation)model;
				validable.RunValidation();
				if (validable.IsValid == false)
					throw new InvalidOperationException("Model is not valid!");
			}

			using (WcfServiceDeployerUI ui = new WcfServiceDeployerUI(model))
			{
				ui.ShowDialog();
			}
		}

		#endregion
	}
}
