using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Windows.Forms;

namespace Softix.Orchestration.Editor.Controls
{
	internal sealed class ComponentTreeNodeComparer : IComparer
	{
		#region IComparer Members

		public int Compare(object x, object y)
		{
			if ((false == (x is TreeNode)) ||
				(false == (y is TreeNode)))
				return 0;

			TreeNode nodex = (TreeNode)x;
			TreeNode nodey = (TreeNode)y;

			if ((nodex.Nodes.Count == 0) && (nodey.Nodes.Count > 0))
				return 1;
			if ((nodex.Nodes.Count > 0) && (nodey.Nodes.Count == 0))
				return -1;
			return StringComparer.OrdinalIgnoreCase.Compare(nodex.Text, nodey.Text);
		}

		#endregion
	}
}
