using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Editor.Controls
{
    internal sealed class VariablesPresenter : ICustomTypeDescriptor
    {
        private VariableValue[] variableValues;

        internal VariablesPresenter(VariableValue[] variableValues)
        {
            this.variableValues = variableValues;
        }

        #region ICustomTypeDescriptor Members

        public AttributeCollection GetAttributes()
        {
            return new AttributeCollection();
        }

        public string GetClassName()
        {
            return "VariablesPresenter";
        }

        public string GetComponentName()
        {
            return "VariablesPresenter";
        }

        public TypeConverter GetConverter()
        {
            return null;
        }

        public EventDescriptor GetDefaultEvent()
        {
            return null;
        }

        public PropertyDescriptor GetDefaultProperty()
        {
            return null;
        }

        public object GetEditor(Type editorBaseType)
        {
            return null;
        }

        public EventDescriptorCollection GetEvents(Attribute[] attributes)
        {
            return null;
        }

        public EventDescriptorCollection GetEvents()
        {
            return null;
        }

        public PropertyDescriptorCollection GetProperties(Attribute[] attributes)
        {
            return this.GetProperties();
        }

        public object GetPropertyOwner(PropertyDescriptor pd)
        {
            return this; // ???
        }

        #endregion

        public PropertyDescriptorCollection GetProperties()
        {
            List<PropertyDescriptor> list = new List<PropertyDescriptor>();

            foreach (VariableValue variableValue in this.variableValues)
            {
                list.Add(new VariablesPresenterPropertyDescriptor(variableValue));
            }

            return new PropertyDescriptorCollection(list.ToArray(), true);
        }
    }

    internal sealed class VariablesPresenterPropertyDescriptor : PropertyDescriptor
    {
		private VariableValue variableValue;

        internal VariablesPresenterPropertyDescriptor(VariableValue variableValue)
			: base(variableValue.Name, null)
		{
            this.variableValue = variableValue;
		}

		#region PropertyDescriptor Members

		public override bool CanResetValue(object component)
		{
			return false;
		}

		public override Type ComponentType
		{
            get { return typeof(VariablesPresenter); }
		}

		public override bool ShouldSerializeValue(object component)
		{
			return false;
		}

		public override bool IsReadOnly
		{
			get { return true; }
		}

		public override Type PropertyType
		{
			get { return (this.variableValue.Value == null) ? typeof(String) : this.variableValue.Value.GetType(); }
		}

		public override object GetValue(object component)
		{
            return this.variableValue.Value;
		}

		public override void ResetValue(object component)
		{
            throw new NotSupportedException();
		}

		public override void SetValue(object component, object value)
		{
            throw new NotSupportedException();
        }

		#endregion
    }
}
