using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Editor.Execution
{
	internal sealed class DummyPropertyDescriptor : PropertyDescriptor
	{
		private Variable variable;

		internal DummyPropertyDescriptor(Variable variable)
			: base(variable.Name, null)
		{
			this.variable = variable;
		}

		#region PropertyDescriptor Members

		public override bool CanResetValue(object component)
		{
			return true;
		}

		public override Type ComponentType
		{
			get { return typeof(DummyObject); }
		}

		public override bool ShouldSerializeValue(object component)
		{
			return false;
		}

		public override bool IsReadOnly
		{
			get { return false; }
		}

		public override Type PropertyType
		{
			get { return this.variable.DataType.DataType; }
		}

		public override object GetValue(object component)
		{
			if (false == (component is DummyObject))
				throw new InvalidOperationException("Invalid component type.");
			DummyObject dummy = (DummyObject)component;
			return dummy[this.variable];
		}

		public override void ResetValue(object component)
		{
			if (false == (component is DummyObject))
				throw new InvalidOperationException("Invalid component type.");
			DummyObject dummy = (DummyObject)component;
			dummy.ResetProperty(this.variable);
		}

		public override void SetValue(object component, object value)
		{
			if (false == (component is DummyObject))
				throw new InvalidOperationException("Invalid component type.");
			DummyObject dummy = (DummyObject)component;
			dummy[this.variable] = value;
		}

		#endregion
	}
}
