using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Editor.Execution
{
	public partial class ModelInputEditor : Form
	{
		private IAmModel model;
		private DummyObject dummy;

		public ModelInputEditor(IAmModel model)
		{
			InitializeComponent();

			this.model = model;
			this.pGrid.SelectedObject = (this.dummy = new DummyObject(this.model.InitialVariables));
		}

		internal static VariableValue[] GetVariableValues(IAmStartComponent component)
		{
			if ((component.ParentModel != null) &&
				(component.ParentModel.InitialVariables != null) &&
				(component.ParentModel.InitialVariables.Length > 0))
			{
				using (ModelInputEditor editor = new ModelInputEditor(component.ParentModel))
				{
					if (editor.ShowDialog() == DialogResult.OK)
					{
						return editor.dummy.GetVariableValues(component.ID);
					}
				}
			}
			return new VariableValue[0];
		}
	}
}