using System;
using System.Collections.Generic;
using System.Text;

using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Components.Events;
using System.ComponentModel;
using Softix.Orchestration.Core.Validation;

namespace Softix.Orchestration.Core.Components
{
    public interface IAmComponent : INotifyPropertyChanged, ISupportValidation
    {
        Guid ID { get; }

        // model
        IAmModel ParentModel { get; set; }

        // input data
        // DataDefinition[] InputDataDefinitions { get; }
        VariableMappingList InputDataMappings { get; }

		// outbound paths
		IAmComponentOutboundPath[] OutboundPaths { get; }

        // info
        String Name { get; set; }
        
        // runtime
        ComponentOutput Run(DataStorage data);

        // event
        event ComponentEvent ComponentChanged;

		// output variables
		Variable[] GetOutboundDataForPath(Guid pathId);

		// design time properties
		string ImageResourcePath { get; }
		double Left { get; set; }
		double Top { get; set; }
		double Width { get; set; }
		double Height { get; set; }
    }
}
