using System;
using System.Collections.Generic;
using System.Text;

using Softix.Orchestration.Core.Models;
using System.ComponentModel;

namespace Softix.Orchestration.Core.Components
{
	public enum ComponentLinkSourceSide
	{
		Left = 0,
		Right = 1
	}

	public enum ComponentLinkDestinationSide
	{
		Left = 0,
		Right = 1,
		Top = 2,
		Bottom = 3
	}

    public interface IAmComponentLink : INotifyPropertyChanged
    {
        Guid ID { get; }
        IAmModel ParentModel { get; set; }

        // source
        IAmComponent SourceComponent { get; }
        IAmComponentOutboundPath SourceComponentPath { get; }
        void SetSourceComponent(IAmComponent component, Guid componentPathID);

        // target
        IAmComponent TargetComponent { get; set; }

		// design time properties
		ComponentLinkSourceSide SourceSide { get; set; }
		ComponentLinkDestinationSide DestinationSide { get; set; }
    }
}
