using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Components
{
    [Serializable]
    internal sealed class SimpleOutboundPath : IAmComponentOutboundPath
    {
        public SimpleOutboundPath()
        {
            this.id = Guid.NewGuid();
        }

        public SimpleOutboundPath(String name)
            : this(0, name)
        { }

        public SimpleOutboundPath(Int32 index, String name)
            : this()
        {
            this.index = index;
            this.name = name;
        }

        #region IAmComponentOutboundPath Members

        #region public Guid ID { get; set; }

        private Guid id;

        public Guid ID
        {
            get { return id; }
            set { id = value; }
        }

        #endregion

        #region public String Name { get; set; }

        private String name;

        public String Name
        {
            get { return name; }
            set { name = value; }
        }

        #endregion

        #region public int Index { get; set; }

        private int index;

        public int Index
        {
            get { return index; }
            set { index = value; }
        }

        #endregion

        #endregion
    }
}
