using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data
{
    [ AttributeUsage(AttributeTargets.Class, Inherited = false, AllowMultiple = false) ]
    public sealed class DataTypeAttribute : Attribute
    {
        private readonly Guid dataTypeId;
        private readonly String dataTypeName;

        public DataTypeAttribute(Guid dataTypeId, String dataTypeName)
        {
            this.dataTypeId = dataTypeId;
            this.dataTypeName = dataTypeName;
        }

        public DataTypeAttribute(String dataTypeId, String dataTypeName)
        {
            this.dataTypeId = new Guid(dataTypeId);
            this.dataTypeName = dataTypeName;
        }

        public Guid DataTypeId { get { return this.dataTypeId; } }
        public String DataTypeName { get { return this.dataTypeName; } }
    }
}
