using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Softix.Orchestration.Core.Data.DataTypes
{
    [DataType("00000000-0000-0000-0000-000000000000", "Enum")]
    internal sealed class EnumDataType<T> : DataTypeBase 
    {
        public EnumDataType()
        {
        }

        public override Type DataType
        {
            get { return typeof(T); }
        }

        public override object DefaultValue
        {
            get { return default(T); }
        }

        public override bool IsAssignableFrom(IAmDataType dataType)
        {
            return false;
        }

        public override object AssignFrom(IAmDataType dataType, object value)
        {
            throw new NotImplementedException();
        }

        #region Serialization

        protected override void Serialize(BinaryWriter writer, object value)
        {
            writer.Write(value.ToString());
        }

        protected override object Deserialize(BinaryReader reader)
        {
            string value = reader.ReadString();
            return (T)Enum.Parse(typeof(T), value);
        }

        #endregion
    }
}
