using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.IO;

namespace Softix.Orchestration.Core.Data.DataTypes
{
	[DataType("c104ba69-9863-4006-9ce4-92ce803fe407", "Image")]
	public sealed class ImageDataType : DataTypeBase
	{
		public override Type DataType
		{
			get { return typeof(Image); }
		}

		public override object DefaultValue
		{
			get { return null; }
		}

		public override bool IsAssignableFrom(IAmDataType dataType)
		{
			return (dataType is ImageDataType);
		}

		public override object AssignFrom(IAmDataType dataType, object value)
		{
			if ((false == (dataType is ImageDataType)) || (false == (value is Image)))
				throw new Exception("The method or operation is not implemented.");
			return value;
		}

		protected override object Deserialize(BinaryReader reader)
		{
			throw new Exception("The method or operation is not implemented.");
		}

		protected override void Serialize(BinaryWriter writer, object value)
		{
			throw new Exception("The method or operation is not implemented.");
		}
	}
}
