using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Core.Data.DataTypes
{
	//	TypeCode.Byte
    [DataType("{318b7b84-e518-40ef-a19f-b6f0ec960d33}", "Unsigned Integer (8 bits)")]
	public sealed class ByteDataType : NumericDataTypeBase<Byte>
	{ }

	//	TypeCode.Decimal
    [DataType("{fd386e01-077a-417d-a59c-9aee0a25bb7d}", "Decimal")]
	public sealed class DecimalDataType : NumericDataTypeBase<Decimal>
	{ }

	//	TypeCode.Double
    [DataType("{1bb88946-936b-4680-8f0b-b23aed0baa9a}", "Float (double precision)")]
	public sealed class DoubleDataType : NumericDataTypeBase<Double>
	{ }

	//	TypeCode.Int16
    [DataType("{d91a63f4-bf8e-4bf5-b0e2-c03539ef6d7a}", "Integer (16 bits)")]
	public sealed class Int16DataType : NumericDataTypeBase<Int16>
	{ }

	//	TypeCode.Int32
    [DataType("{eddac7e2-a1ca-4a7d-990b-0389160b31a6}", "Integer (32 bits)")]
	public sealed class Int32DataType : NumericDataTypeBase<Int32>
	{ }

	//	TypeCode.Int64
    [DataType("{ac0b1d01-49a9-4ad2-9d03-20d476f6c1a3}", "Integer (64 bits)")]
	public sealed class Int64DataType : NumericDataTypeBase<Int64>
	{ }

	//	TypeCode.SByte
    [DataType("{27b37e90-a1af-49c5-a325-b4d764d92aec}", "Integer (8 bytes)")]
	public sealed class SByteDataType : NumericDataTypeBase<SByte>
	{ }

	//	TypeCode.Single
    [DataType("{fc43ebe7-92e8-4ddf-8e67-428f4b19146c}", "Float (single precision)")]
	public sealed class SingleDataType : NumericDataTypeBase<Single>
	{ }

	//	TypeCode.UInt16
    [DataType("{8b4c062e-707f-40df-94a2-e6d2b0de61a9}", "Unsigned Integer (16 bits)")]
	public sealed class UInt16DataType : NumericDataTypeBase<UInt16>
	{ }

	//	TypeCode.UInt32
    [DataType("{2a88c3ae-78bf-4fdf-9707-56cc99d71f81}", "Unsigned Integer (32 bits)")]
	public sealed class UInt32DataType : NumericDataTypeBase<UInt32>
	{ }

	//	TypeCode.UInt64
    [DataType("{ced71add-c17e-4a6f-af1b-f4645859790b}", "Unsigned Integer (64 bits)")]
	public sealed class UInt64DataType : NumericDataTypeBase<UInt64>
	{ }
}
