using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace Softix.Orchestration.Core.Data
{
	public interface IAmDataType
	{
		Guid DataTypeId { get; }
		String DataTypeName { get; }
		Type DataType { get; }

		TypeConverter DataTypeConverter { get; }
        bool IsAssignableFrom(IAmDataType dataType);
        object AssignFrom(IAmDataType dataType, object value);

		Object FromBase64(String serializedData);
		String ToBase64(Object value);

		Object DefaultValue { get; }
	}

	public interface IAmNumericDataType : IAmDataType
	{
		TypeCode TypeCode { get; }
		Object ConvertTo(IAmNumericDataType type, Object value);
	}

	public interface IAmArrayDataType : IAmDataType
	{
		IAmDataType ArrayItemDataType { get; }
	}
}
