using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public class ConstantValueMapper : IVariableMapper
    {
        public ConstantValueMapper()
        { }

        public ConstantValueMapper(Object value)
            : this()
        {
            this.constantValue = value;
        }

        #region public Object ConstantValue { get; set; }

        private Object constantValue;

        public Object ConstantValue
        {
            get { return constantValue; }
            set { constantValue = value; }
        }

        #endregion

        #region IVariableMapper Members

        public virtual Object BuildData(DataStorage storage)
        {
            return this.constantValue;
        }

		public Variable[] MappedVariables { get { return null; } }

        #endregion

        public override string ToString()
        {
            return (this.constantValue == null) ? "(null)" :
                this.constantValue.ToString() + " (" + this.constantValue.GetType().Name + ")";
        }
    }
}
