using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public class SingleVariableMapper : IVariableMapper
    {
        public SingleVariableMapper()
        { }

        public SingleVariableMapper(Variable var)
            : this()
        {
            this.variable = var;
        }

        #region public Variable Variable { get; set; }

        private Variable variable;

        public Variable Variable
        {
            get { return variable; }
            set { variable = value; }
        }

        #endregion

        #region IVariableMapper Members

        protected virtual Object GetData(DataStorage storage, Object value)
        {
            return value;
        }

        public object BuildData(DataStorage storage)
        {
            return this.GetData(
                storage,
                storage.GetVariableValue(this.variable)
                );
        }

		public Variable[] MappedVariables
		{
			get { return new Variable[] { this.variable }; }
		}

        #endregion

        public override string ToString()
        {
            return (this.variable == null) ? "(no variable)" : this.variable.Name;
        }
    }
}
