using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data
{
    [Serializable]
    public sealed class VariableList : List<Variable>
    {
        public VariableList() : base()
        { }

        public VariableList(Variable[] definitions)
            : this()
        {
            if (definitions != null)
                base.AddRange(definitions);
        }

        public VariableList UniqueVariables
        {
            get
            {
                VariableList list = new VariableList();
                // add only variables not already added
                this.ForEach(
                    delegate(Variable tmpVar)
                    {
                        if (list.Exists(
                            delegate(Variable tmpVar2)
                            {
                                return ((tmpVar2.SourceComponentID == tmpVar.SourceComponentID) &&
                                    (tmpVar2.Name == tmpVar.Name) &&
                                    (tmpVar2.DataType == tmpVar.DataType));
                            }) == false)
                        {
                            list.Add(tmpVar);
                        }
                    });

                return list;
            }
        }
    }
}
