using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data
{
    [Serializable]
    public sealed class VariableMappingList : List<VariableMapping>
    {
        public VariableMappingList()
            : base()
        { }

        public VariableMappingList(VariableMapping[] mappings)
            : base(mappings)
        {
        }

        public VariableMapping GetMappingForVariable(String variableName)
        {
            return this.Find(
                delegate(VariableMapping mapping)
                {
                    return (mapping.VariableName == variableName);
                });
        }
    }
}
