using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data
{
    [ Serializable ]
    public class VariableNotFoundException : ApplicationException
    {
        public VariableNotFoundException()
        { }

        public VariableNotFoundException(string variableName)
            : base("Variable '" + variableName + "' not found.")
        {
            this.variableName = variableName;
        }

        public VariableNotFoundException(string variableName, Exception inner)
            : base("Variable '" + variableName + "' not found.", inner)
        {
            this.variableName = variableName;
        }

        #region serialization methods

        [ System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never) ]
        protected VariableNotFoundException(
          System.Runtime.Serialization.SerializationInfo info,
          System.Runtime.Serialization.StreamingContext context)
            : base(info, context)
        {
            this.variableName = info.GetString("variableName");
        }

        [ System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never) ]
        public override void GetObjectData(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context)
        {
            base.GetObjectData(info, context);

            info.AddValue("variableName", this.variableName);
        }

        #endregion

        #region public String VariableName { get; set; }

        private String variableName;

        public String VariableName
        {
            get { return variableName; }
            set { variableName = value; }
        }

        #endregion
    }
}
