using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data
{
    [Serializable]
    public sealed class VariableValue
    {
        private String name;
        private Guid componentId;
        private Object value;

        public VariableValue()
        { }

        public VariableValue(String name, Guid componentId, Object value)
            : this()
        {
            this.name = name;
            this.value = value;
            this.componentId = componentId;
        }

        #region public String Name { get; }

        public String Name { get { return this.name; } }

        #endregion
        #region public Object Value { get; set; }

        public Object Value
        {
            get { return this.value; }
            set { this.value = value; }
        }

        #endregion
		public Guid ComponentId { get { return this.componentId; } }
    }
}
