using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.Core.Execution
{
    public delegate void ComponentExecutedEventHandler(object sender, ComponentExecutedEventArgs args);

    public sealed class ComponentExecutedEventArgs : EventArgs
    {
        private IAmComponent component;
        private IAmComponentLink outboundLink;
        private TimeSpan executionTime;

        public ComponentExecutedEventArgs(IAmComponent component, IAmComponentLink outboundLink, TimeSpan executionTime)
        {
            this.component = component;
            this.outboundLink = outboundLink;
            this.executionTime = executionTime;
        }

        public IAmComponent Component { get { return this.component; } }

        public IAmComponentLink OutboundLink { get { return this.outboundLink; } }

        public TimeSpan ExecutionTime { get { return this.executionTime; } }
    }
}
