using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.Core.Execution
{
    public delegate void ComponentExecutionFailedEventHandler(object sender, ComponentExecutionFailedEventArgs args);

    public sealed class ComponentExecutionFailedEventArgs : EventArgs
    {
        private IAmComponent component;
        private Exception exception;

        public ComponentExecutionFailedEventArgs(IAmComponent component, Exception exception)
        {
            this.component = component;
            this.exception = exception;
        }

        public IAmComponent Component { get { return this.component; } }

        public Exception Exception { get { return this.exception; } }
    }
}
