using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Core.Execution
{
    public delegate void ModelExecutionFinishedEventHandler(object sender, ModelExecutionFinishedEventArgs args);

    public sealed class ModelExecutionFinishedEventArgs : EventArgs
    {
        private IAmModel model;
        private Exception exception;
        private VariableValue[] finalData;

        public ModelExecutionFinishedEventArgs(IAmModel model)
        {
            this.model = model;
        }

        public ModelExecutionFinishedEventArgs(IAmModel model, Exception exception)
            : this(model)
        {
            this.exception = exception;
        }

        public ModelExecutionFinishedEventArgs(IAmModel model, VariableValue[] finalData)
            : this(model)
        {
            this.finalData = finalData;
        }

        public IAmModel Model { get { return this.model; } }

        public Exception Exception { get { return this.exception; } }
        public bool HasFailed { get { return (this.exception != null); } }

        public VariableValue[] FinalData { get { return this.finalData; } }
    }
}
