using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.Core.Execution
{
    public delegate void ModelExecutionStartedEventHandler(object sender, ModelExecutionStartedEventArgs args);

    public sealed class ModelExecutionStartedEventArgs : EventArgs
    {
        private IAmModel model;
        private VariableValue[] initialData;

        public ModelExecutionStartedEventArgs(IAmModel model)
        {
            this.model = model;
        }

        public ModelExecutionStartedEventArgs(IAmModel model, VariableValue[] initialData)
            : this(model)
        {
            this.initialData = initialData;
        }

        public IAmModel Model { get { return model; } }

        public VariableValue[] InitialData { get { return this.initialData; } }
    }
}
