using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.DefaultComponents.ImageProcessing
{
	[Serializable]
	[Component("Grayscale", "Imaging.Per Pixel Filters")]
	public sealed class GrayscaleComponent : BasePerPixelFilter
	{
		public GrayscaleComponent()
			: base("Grayscale")
		{ }

		protected override Pixel ProcessPixel(Pixel pixel)
		{
			byte x = (byte)(
				.299 * pixel.Red +
				.587 * pixel.Green +
				.114 * pixel.Blue
				);
			return new Pixel(pixel.Alpha, x, x, x);
		}
	}
}
