using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.DefaultComponents.ImageProcessing
{
	[Serializable]
	[Component("Invert Image", "Imaging.Per Pixel Filters")]
	public sealed class InvertImageComponent : BasePerPixelFilter
	{
		public InvertImageComponent()
			: base("Invert Image")
		{ }

		protected override Pixel ProcessPixel(Pixel pixel)
		{
			return new Pixel(
				pixel.Alpha,
				(byte)(255 - pixel.Red),
				(byte)(255 - pixel.Green),
				(byte)(255 - pixel.Blue));
		}
	}
}
