using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;
using System.Drawing;
using System.ComponentModel;
using Softix.Orchestration.Core.Data;
using System.Drawing.Imaging;

namespace Softix.Orchestration.DefaultComponents.ImageProcessing
{
	[Serializable]
	[Component("Save Image to File", "Imaging")]
	public sealed class SaveImageComponent : ComponentBase
	{
		private const string PATH = "saved";

		public SaveImageComponent()
		{
			base.AddOutboundPath(PATH);
			base.Name = "Save Image";
		}

		#region Input: Image

		[NonSerialized]
		private Image image;

		[Browsable(false)]
		[InputVariable]
		public Image Image
		{
			get { return this.image; }
			set { this.image = value; }
		}

		#endregion
		#region Input: FileName

		[NonSerialized]
		private string fileName;

		[Browsable(false)]
		[InputVariable]
		public string FileName
		{
			get { return this.fileName; }
			set { this.fileName = value; }
		}

		#endregion

		public override ComponentOutput Run(DataStorage storage)
		{
			this.image.Save(this.fileName, ImageFormat.Png);
			return new ComponentOutput(base.GetPathID(PATH));
		}
	}
}
