using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;
using System.ComponentModel;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.DefaultComponents.InsertData
{
    [ Serializable ]
    [Component("Insert Text", "Insert Data")]
    public sealed class InsertText : ComponentBase
    {
        public const string PATH_TEXT = "Text";

        public InsertText()
        {
            base.AddOutboundPath(PATH_TEXT);
            base.Name = "Insert Text";
        }

        #region Properties - Inputs

        [ NonSerialized ]
        private String text = String.Empty;

        [ InputVariable ]
        [ Browsable(false) ]
        public String Text
        {
            get { return this.text; }
            set { this.text = value; }
        }

        #endregion
        #region Properties - Outputs

        [ NonSerialized ]
        private String outputText = String.Empty;

        [ OutputVariable(PATH_TEXT) ]
        [ Browsable(false) ]
        public String OutputText
        {
            get { return this.outputText; }
            set { this.outputText = value; }
        }

        #endregion

        public override ComponentOutput Run(DataStorage storage)
        {
            this.outputText = this.text;
            return new ComponentOutput(base.GetPathID(PATH_TEXT));
        }
    }
}
