using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Data;
using System.ComponentModel;
using System.Drawing;
using Softix.Orchestration.DefaultComponents.Interactive.Controls;

namespace Softix.Orchestration.DefaultComponents.Interactive
{
	[Serializable]
	[Component("Display Image", "Interactive")]
	public sealed class DisplayImageComponent : InteractiveComponentBase
	{
		private const string PATH = "continue";

		public DisplayImageComponent()
			: base(PATH)
		{
			base.AddOutboundPath(PATH);
			base.Name = "Display Image";
		}

		#region Input: Image

		[NonSerialized]
		private Image image;

		[Browsable(false)]
		[InputVariable]
		public Image Image
		{
			get { return this.image; }
			set { this.image = value; }
		}

		#endregion

		protected override ComponentOutput InternalRun(DataStorage storage)
		{
			using (DisplayImageForm form = new DisplayImageForm(this.image))
			{
				form.ShowDialog();
			}

			return new ComponentOutput(base.GetPathID(PATH));
		}
	}
}
