using System;
using System.Collections.Generic;
using System.Text;
using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Data;

namespace Softix.Orchestration.DefaultComponents.Interactive
{
	[Serializable]
	public abstract class InteractiveComponentBase : ComponentBase
	{
		private string noUIPath;

		public InteractiveComponentBase(string noUIPath)
		{
			this.noUIPath = noUIPath;
		}

		public override ComponentOutput Run(DataStorage storage)
		{
			if (Environment.UserInteractive == false)
			{
				return new ComponentOutput(base.GetPathID(this.noUIPath));
			}

			return this.InternalRun(storage);
		}

		protected abstract ComponentOutput InternalRun(DataStorage storage);
	}
}
