using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.DefaultComponents.Math
{
    [Serializable]
    [Component("Sum Array", "Math")]
    public sealed class MathComplexAdd : ComponentBase
    {
        public const string PATH_SUM = "Sum";

        public MathComplexAdd()
        {
            base.AddOutboundPath(PATH_SUM);
            base.Name = "Sum Array";
        }

        #region public Int32[] Numbers { get; set; }

        [NonSerialized]
        private IEnumerable<Int32> numbers;

        [ InputVariable ]
        [ Browsable(false) ]
        public IEnumerable<Int32> Numbers
        {
            get { return numbers; }
            set { numbers = value; }
        }

        #endregion

        #region public int Sum { get; set; }

        [NonSerialized]
        private int sum = 0;

        [OutputVariable(MathSimpleAdd.PATH_SUM)]
        [Browsable(false)]
        public int Sum
        {
            get { return sum; }
            set { sum = value; }
        }

        #endregion

        public override ComponentOutput Run(DataStorage storage)
        {
            int sum = 0;

            if (this.numbers != null)
            {
                foreach (Int32 x in this.numbers)
                    sum += x;
            }

            this.sum = sum;
            return new ComponentOutput(base.GetPathID(PATH_SUM));
        }
    }
}
