using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;

using Softix.Drawing.Diagram.Core.Events;

namespace Softix.Drawing.Diagram.Core
{
    public interface IDiagram
    {
        IDiagramObject[] DiagramObjects { get; }
        IDiagramObjectLink[] DiagramObjectLinks { get; }
        bool ContainsObject(IDiagramObject obj);
        bool ContainsObjectLink(IDiagramObjectLink link);

        void AddDiagramObject(IDiagramObject diagramObject);
        void RemoveDiagramObject(IDiagramObject diagramObject);

        void AddDiagramObjectLink(IDiagramObjectLink diagramLink);
        void RemoveDiagramObjectLink(IDiagramObjectLink diagramLink);

        void AddDiagramEntities(IDiagramEntity[] entities);

        event DiagramObjectEventHandler DiagramObjectAdded;
        event DiagramObjectEventHandler DiagramObjectRemoved;
        event DiagramObjectLinkEventHandler DiagramObjectLinkAdded;
        event DiagramObjectLinkEventHandler DiagramObjectLinkRemoved;

        event EventHandler ShouldRedraw;

        void NewLinkFromUI(
            IDiagramObject source,
            IDiagramObjectPort sourcePort,
            DiagramObjectPortAlign sourcePortAlign,
            IDiagramObject targetObject,
            DiagramObjectEdge targetEdge);
        void SomethingDropedOnUI(object dropedObject, Point location);

        String ErrorMessage { get; }
        void ClearErrorMessage();
    }
}
