using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;

using Softix.Drawing.Diagram.Core;
using Softix.Drawing.Diagram.Resouces;

namespace Softix.Drawing.Diagram.Simple
{
    public class SimpleDiagramArtifact : IDiagramArtifact
    {
        public SimpleDiagramArtifact()
        {
            this.id = Guid.NewGuid();
            this.text = "";
        }

        public SimpleDiagramArtifact(Image image, DiagramObjectEdge edge)
            : this()
        {
            this.image = image;
            this.edge = edge;
        }

        #region public Image Image { get; set; }

        private Image image;

        public Image Image
        {
            get { return image; }
            set { image = value; }
        }

        #endregion
        #region public DiagramObjectEdge Edge { get; set; }

        private DiagramObjectEdge edge;

        public DiagramObjectEdge Edge
        {
            get { return edge; }
            set { edge = value; }
        }

        #endregion

        #region public Guid ID { get; set; }

        private Guid id;

        public Guid ID
        {
            get { return id; }
            set { id = value; }
        }

        #endregion
        #region public String Text { get; set; }

        private String text;

        public String Text
        {
            get { return text; }
            set { text = value; }
        }

        #endregion

        #region statics

        // warning

        public static IDiagramArtifact GetWarningArtifact(DiagramObjectEdge edge)
        {
            return new SimpleDiagramArtifact(Resources.WarningImage, edge);
        }

        public static IDiagramArtifact WarningArtifact
        {
            get { return SimpleDiagramArtifact.GetWarningArtifact(DiagramObjectEdge.Left); }
        }

        // exception 

        public static IDiagramArtifact GetExceptionArtifact(DiagramObjectEdge edge)
        {
            return new SimpleDiagramArtifact(Resources.ExceptionImage, edge);
        }

        public static IDiagramArtifact ExceptionArtifact
        {
            get { return SimpleDiagramArtifact.GetExceptionArtifact(DiagramObjectEdge.Left); }
        }

        // start

        public static IDiagramArtifact GetStartArtifact(DiagramObjectEdge edge)
        {
            return new SimpleDiagramArtifact(Resources.StartImage, edge);
        }

        public static IDiagramArtifact StartArtifact
        {
            get { return SimpleDiagramArtifact.GetStartArtifact(DiagramObjectEdge.Right); }
        }

        // end

        public static IDiagramArtifact GetEndArtifact(DiagramObjectEdge edge)
        {
            return new SimpleDiagramArtifact(Resources.EndImage, edge);
        }

        public static IDiagramArtifact EndArtifact
        {
            get { return SimpleDiagramArtifact.GetEndArtifact(DiagramObjectEdge.Right); }
        }

        #endregion
    }
}
