using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Components
{
    [Serializable]
    public sealed class ComponentOutput
    {
        Dictionary<String, Object> variables = null;

        public ComponentOutput()
        {
            this.variables = new Dictionary<String, Object>();
        }

        public ComponentOutput(Guid pathID)
            : this()
        {
            this.outboundPathID = pathID;
        }

        #region public Guid OutboundPathID { get; set; }

        private Guid outboundPathID;

        public Guid OutboundPathID
        {
            get { return outboundPathID; }
            set { outboundPathID = value; }
        }

        #endregion

        public Object this[String varName]
        {
            get
            {
                if (this.variables.ContainsKey(varName) == true)
                    return this.variables[varName];
                return null;
            }
            set
            {
                this.variables[varName] = value;
            }
        }
    }
}
