using System;
using System.Collections.Generic;
using System.Text;

using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Components.Events;

namespace Softix.Orchestration.Core.Components
{
    public interface ISOComponent
    {
        Guid ID { get; }

        // model
        ISOModel ParentModel { get; set; }

        // input data
        // DataDefinition[] InputDataDefinitions { get; }
        VariableMappingList InputDataMappings { get; }

        // outbound paths
        ISOComponentOutboundPath[] OutboundPaths { get; }
        Variable[] GetDataDefinitionsForPath(Guid pathID);
        Variable[] GetDataDefinitionsForPath(ISOComponentOutboundPath path);

        // info
        String Name { get; set; }
        
        // runtime
        ComponentOutput Run();

        // event
        event ComponentEvent ComponentChanged;
    }
}
