using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public abstract class ArrayElementMapper : SingleVariableMapper
    {
        public ArrayElementMapper()
            : base()
        { }

        public ArrayElementMapper(Variable var)
            : base(var)
        { }

        #region IVariableMapper Members

        protected abstract Int32 GetIndex(DataStorage storage, Array array);

        protected override object GetData(DataStorage storage, object value)
        {
            Array array = value as Array;
            if (array == null)
                throw new InvalidOperationException("Variable '" + base.ToString() + "' is null or not an array.");

            return array.GetValue(this.GetIndex(storage, array));
        }

        #endregion
    }
}
