using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public sealed class ArrayVariableMapper : IVariableMapper
    {
        public ArrayVariableMapper(Type type)
        {
            this.mappers = new List<IVariableMapper>();
            this.type = type;
        }

        #region public List<IVariableMapper> Mappers { get; set; }

        private List<IVariableMapper> mappers;

        public List<IVariableMapper> Mappers
        {
            get { return mappers; }
            set { mappers = value; }
        }

        #endregion
        #region public Type Type { get; set; }

        private Type type;

        public Type Type
        {
            get { return type; }
            set { type = value; }
        }

        #endregion

        public object BuildData(DataStorage storage)
        {
            ArrayList list = new ArrayList();
            Type type = this.type.GetElementType();

            if (this.mappers != null)
            {
                foreach (IVariableMapper mapper in mappers)
                {
                    Object obj = mapper.BuildData(storage);
                    if (obj == null)
                        continue;

                    if (type.IsAssignableFrom(obj.GetType()) == true)
                    {
                        list.Add(obj);
                    }
                    else if ((obj.GetType().IsArray == true) &&
                        (typeof(ICollection).IsAssignableFrom(obj.GetType()) == true) &&
                        (type.IsAssignableFrom(obj.GetType().GetElementType()) == true))
                    {
                        list.AddRange((ICollection)obj);
                    }
                }
            }

            return list.ToArray(type);
        }
    }
}
