using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public class CountElementsMapper : SingleVariableMapper
    {
        public CountElementsMapper()
            : base()
        { }

        public CountElementsMapper(Variable var)
            : base(var)
        { }

        #region IVariableMapper Members

        protected override object GetData(DataStorage storage, Object value)
        {
            Array array = value as Array;
            if (array == null)
                throw new InvalidOperationException("Variable '" + base.ToString() + "' is null or not an array.");

            return array.GetLength(0);
        }

        #endregion

        public override string ToString()
        {
            return base.ToString() + "[ count() ]";
        }
    }
}
