using System;
using System.Collections.Generic;
using System.Text;

namespace Softix.Orchestration.Core.Data.Mappers
{
    [Serializable]
    public class CustomIndexMapper : ArrayElementMapper
    {
        public CustomIndexMapper()
            : base()
        { }

        public CustomIndexMapper(Variable var)
            : base(var)
        { }

        #region public IVariableMapper IndexMapper { get; set; }

        private IVariableMapper myVar;

        public IVariableMapper IndexMapper
        {
            get { return myVar; }
            set { myVar = value; }
        }

        #endregion

        protected override int GetIndex(DataStorage storage, Array array)
        {
            return (Int32)this.IndexMapper.BuildData(storage);
        }

        public override string ToString()
        {
            if (this.IndexMapper == null)
            {
                return base.ToString() + "[ (no index defined) ]";
            }
            else
            {
                return base.ToString() + "[ " + this.IndexMapper.ToString() + " ]";
            }
        }
    }
}
