using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.DefaultComponents.Math
{
    [Serializable]
    public sealed class MathSimpleAdd : ComponentBase
    {
        public const string PATH_SUM = "Sum";

        public MathSimpleAdd()
        {
            base.AddOutboundPath(PATH_SUM);
            base.Name = "Simple Sum";
        }

        #region public int FirstNumber { get; set; }

        [NonSerialized]
        private int firstNumber = 0;

        [InputVariable]
        [Browsable(false)]
        public int FirstNumber
        {
            get { return firstNumber; }
            set { firstNumber = value; }
        }

        #endregion
        #region public int SecondNumber { get; set; }

        [NonSerialized]
        private int secondNumber = 0;

        [ InputVariable ]
        [Browsable(false)]
        public int SecondNumber
        {
            get { return secondNumber; }
            set { secondNumber = value; }
        }

        #endregion

        #region public int Sum { get; set; }

        [NonSerialized]
        private int sum = 0;

        [ OutputVariable(MathSimpleAdd.PATH_SUM) ]
        [ Browsable(false) ]
        public int Sum
        {
            get { return sum; }
            set { sum = value; }
        }

        #endregion

        public override ComponentOutput Run()
        {
            this.sum = this.firstNumber + this.secondNumber;
            return new ComponentOutput(base.GetPathID(PATH_SUM));
        }
    }
}
