using System;
using System.Collections.Generic;
using System.Text;

using Softix.Drawing.Diagram.Simple;
using Softix.Orchestration.Core.Components;

namespace Softix.Orchestration.Editor.Diagram
{
    public sealed class OrchestrationObjectPort : SimpleDiagramObjectPort
    {
        public OrchestrationObjectPort()
            : base()
        { }

        public OrchestrationObjectPort(ISOComponentOutboundPath path)
        {
            base.Index = path.Index;
            this.Path = path;
        }

        #region public ISOComponentOutboundPath Path { get; set; }

        private ISOComponentOutboundPath path;

        public ISOComponentOutboundPath Path
        {
            get { return path; }
            set
            {
                path = value;
                this.Refresh();
            }
        }

        #endregion

        internal void Refresh()
        {
            if (this.path == null)
            {
                base.ID = Guid.Empty;
                base.Text = "(no path)";
                base.Index = 0;
            }
            else
            {
                base.ID = this.path.ID;
                base.Text = this.path.Name;
                base.Index = this.path.Index;
            }
        }
    }
}
