using System;
using System.Collections.Generic;
using System.Text;

using Softix.Orchestration.Core.Components;
using Softix.Orchestration.Core.Models;
using Softix.Orchestration.Core.Data;
using Softix.Orchestration.Core.Data.Mappers;

namespace Softix.Orchestration.Editor.Editors.MappingEditors
{
    public static class VariableMappingEditorFactory
    {
        public static IVariableMapperUI GetMappingUIForType(
            ISOModel model,
            ISOComponent component,
            IVariableMapper mapper,
            Variable target)
        {
            IVariableMapperUI ui = null;

            if (target.Type.IsArray == false)
            {
                ui = new SingleVariablePicker();
            }
            else
            {
                ui = new ArrayVariableBuilder();
            }

            if (ui != null)
                ui.Load(model, component, target.Type, mapper);
            return ui;
        }

        public static String GetVariableDisplayName(ISOModel model, Variable var)
        {
            string ret = "";
            if (model != null)
            {
                ISOComponent component = model.GetComponent(var.SourceComponentID);
                ret += (component != null) ? component.Name + ": " : "(no component):";
            }

            ret += var.Name;
            ret += (var.Type == null) ? "(no type)" : ("(" + var.Type.Name + ")");
            return ret;
        }
    }
}
