using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Softix.Orchestration.Core.Validation;

namespace Softix.Orchestration.Editor
{
    public partial class ValidationBreaksViewer : Form
    {
        public ValidationBreaksViewer(ValidationBreak[] breaks)
        {
            InitializeComponent();

            if ((breaks != null) && (breaks.Length > 0))
            {
                foreach (ValidationBreak vb in breaks)
                {
                    ListViewItem item = new ListViewItem();

                    if (vb.Source != null)
                        item.Text = vb.Source.ToString();
                    else
                        item.Text = "(no source)";

                    item.SubItems.Add(vb.Reason);
                    item.Tag = vb;

                    this.lvw.Items.Add(item);
                }
            }
            else
            {
                splitter.Enabled = false;
            }
        }
    }
}